 
 

#include <stdlib.mqh>
//---
#import "FX_Neural_Net_ATM_Library.ex4"
void InNormalize(double& aa[]);
int InitNet_WW_SOM(string NameWW, double& ww[][]);
void NeuroNet_SOM(string NameWW, double in[], double& ww[][], double& Out_Net[], int Nk, 
                   bool Tranning=false, double myu=0.0001);
#import
//---

#property indicator_chart_window
#property indicator_minimum -1.2
#property indicator_maximum 1.2
#property indicator_level1 1.0
#property indicator_level2 -1.0
#property indicator_level3 0.0
#property indicator_levelcolor Blue
#property indicator_buffers 8
#property indicator_color1 Magenta
#property indicator_color2 Red


//---- buffers
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];
double Buffer7[];
double Pips_low[];
//---
int XX;
extern int Min=1440;
extern int Nk=30; //  
extern int PerMA=2; // 
extern int price=6;
extern int back=0;
extern bool NumberOnChart=true;
extern color numbers_color=Magenta;
extern color COLOR_FIND=Blue;
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
   string Name_Net1; //   
   //---
   double in_neuro[];
     double in_neuro2[];
   double Ind_Koh[][1000]; // ()   Wi *  Nj 
   double Out_Net1[]; //  1
   int M;
   //-----------------------------------------------------------------+
   //---
   double temp[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
IndicatorShortName("Koh= "+"("+Min+") Minutes!"+" *** MA="+PerMA);
SetIndexStyle(0,DRAW_LINE);
SetIndexBuffer(0,Buffer1);
SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(1,Buffer2);
SetIndexStyle(2,DRAW_LINE);
SetIndexBuffer(2,Buffer3);
SetIndexBuffer(3,Buffer4);
SetIndexBuffer(4,Buffer5);
SetIndexBuffer(5,Buffer6);
SetIndexBuffer(6,Buffer7);
SetIndexBuffer(7,Pips_low);
   //---
   if(Nk>1000) { Nk=1000; }
   //---
   ArrayResize(temp,iBars(NULL,0));
   //---
   string Net_param[3];
   //---
   M=(Min/Period());////1440
   //---
   ArrayResize(Ind_Koh,M);
   //---
  //Name_Net1=StringConcatenate("FX_NEURAL_NET_PREDICTOR ",Symbol()+" ",Period(),";",M,";",Nk);//////<=======================IMPORTANT CHANGE, PERIOD WASNT THERE
  Name_Net1=StringConcatenate("Ind_Koh_",Symbol(),";",M,";",Nk);
   //---
   int count=StrSplit(Name_Net1,Net_param,";");
   if (count!=3)
   {
      Print("    ");
      return(0);
   }
   //---
   Nk=StrToInteger(Net_param[2]);
   //---
   ArrayResize(in_neuro,M);
   // ArrayResize(in_neuro2,M);
   //---
   //+----------------------------------------------------------------------------------------+
   //|                                                                       |
   //+----------------------------------------------------------------------------------------+

   //-----------------------------------------------------------------------------------------+

   //---
  // Learning_History(Tranning,0.0001);
   //---
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
ObjectsDeleteAll(); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   //---
   XX= (Min/Period()/3)*2;//////////////////////////////////////////////////////
   
   
      int rez=InitNet_WW_SOM(Name_Net1,Ind_Koh);
      bool Tranning=true;
   //---
   if (rez==1) { Tranning=false; }
    Learning_History(Tranning,0.0001);
    
   //=========================== =================================
   //----------------------------------------------------------------------------+
   //|                                                       |
   //----------------------------------------------------------------------------+
   if ( Bars<M ) return(0);
   //---
   datetime begin_time, cur_time;
   int      cur_bar_day, begin_bar;
   int i;
   //---
   cur_time=iTime(NULL,0,0);
   cur_bar_day=iBarShift(NULL,Min,cur_time);
   //---
   begin_time=iTime(NULL,Min,cur_bar_day);
   begin_bar=iBarShift(NULL,0,begin_time);
   //---   
   //Comment("M= ",M," begin_bar= ",begin_bar);
   //---
   ArrayInitialize(in_neuro,0.0);
   //---
   if( begin_bar>M ) { Print(": -   "); begin_bar=M; }
   //---
   for( i=0; i<=XX-1; i++)
   //   for( i=0; i<=begin_bar-1; i++)
   {
  //     in_neuro[i]=iMA(NULL,0,PerMA,0,MODE_EMA,price,begin_bar-i+back)-iOpen(NULL,Min,cur_bar_day+back);//iCustom(NULL,0,"hma",5,2,0,0,0,begin_bar-i)-iOpen(NULL,Min,cur_bar_day);
  // 
   in_neuro[i]=iMA(NULL,0,PerMA,0,MODE_EMA,price,XX-i+back)-iOpen(NULL,0,XX+back);//iCustom(NULL,0,"hma",5,2,0,0,0,begin_bar-i)-iOpen(NULL,Min,cur_bar_day);
  
     
      }//
   InNormalize(in_neuro);
   //---
  // if( begin_bar>=XX/*4*/ )
   {
    //---
    NeuroNet_SOM(Name_Net1,in_neuro,Ind_Koh,Out_Net1,Nk,false,0);
    //---
    int Vjt=ArrayMaximum(Out_Net1);
    static int old_Vjt=-1;
    //---
    if( Vjt!=old_Vjt && NumberOnChart)
    {
    ObjectCreate(" "+Time[XX+back+5]+" ", OBJ_TEXT, 0, Time[XX+back+5], High[XX+back+5] );
    ObjectSetText(" "+Time[XX+back+5]+" ", " "+Vjt, 30, "Times New Roman", COLOR_FIND);
      old_Vjt=Vjt;
    }
     Buffer2[0]=Vjt;
    //---
   }
    //Comment(" in_neuro[0]= ",in_neuro[0], " in_neuro[1]= ",in_neuro[1],
    //       " in_neuro[2]= ",in_neuro[2], " in_neuro[3]= ",in_neuro[3]);
   //----------------------------------------------------------------------------+
   //|                                                    |
   //----------------------------------------------------------------------------+      
   //  
   //---
   int n2=ArraySize(in_neuro);
   SetIndexDrawBegin(1,Bars-begin_bar);
   //---
   for( i=0; i<=begin_bar-1; i++)
   {
     // Buffer2[begin_bar-i]=in_neuro[i]; 
   }
   //---
   int n1=ArraySize(temp);
   for( i=n1-1; i>=begin_bar; i--)
   {
     // Buffer1[i]=temp[i]; 
   }
   /*
   //---
   int n1=ArraySize(Out_Net1);
   SetIndexDrawBegin(0,Bars-n1);
   //---
   for( i=0; i<=n1-1; i++)
   {
      Buffer1[i]=Out_Net1[i]; 
   }
   //---
   */
   //---
    err();
   //----
   return(0);
  }
//----------------------------------------------------------------------------+
//|                                                          |
//----------------------------------------------------------------------------+ 
void Learning_History(bool Tranning=true, double muy=0.0001)
{
  
   datetime start_time,some_time,cur_time;
   int start_bar, shift, begin, cur_bar_day, count;
   int Vjt,Vjt2;
   //---
   cur_time=iTime(NULL,0,0);
   cur_bar_day=iBarShift(NULL,Min,cur_time);
   //---
   start_time=iTime(NULL,0,iBars(NULL,0)-1);
   start_bar=iBarShift(NULL,Min, start_time);
   //---
   for( shift=start_bar-1; shift>=cur_bar_day+1; shift--)
   {
      some_time=iTime(NULL,Min,shift);
      begin=iBarShift(NULL,0,some_time);
      //---
      for(int i=0; i<=M-1; i++)
      {
         in_neuro[i]=iMA(NULL,0,PerMA,0,MODE_EMA,price,begin-i)-iOpen(NULL,Min,shift);
         // in_neuro[i]=iBWMFI(NULL, 0  , begin-i)- iBWMFI(NULL, Min  , shift);
        // in_neuro2[i]=Buffer3[i];
      }
      //---
      InNormalize(in_neuro);
      //InNormalize(in_neuro2);
      //---
      for( i=0; i<=M-1; i++)
      {
         temp[begin-i]=in_neuro[i]; 
      }
      //---
      NeuroNet_SOM(Name_Net1,in_neuro,Ind_Koh,Out_Net1,Nk,Tranning,muy);
         
      
      //---
      Vjt=ArrayMaximum(Out_Net1);
      
    //  NeuroNet_SOM(Name_Net1,in_neuro2,Ind_Koh,Out_Net1,Nk,Tranning,muy);
      //  Vjt2=ArrayMaximum(Out_Net1);
      //---
      if( NumberOnChart )
      {
      ObjectCreate(" "+Time[begin]+" "+count, OBJ_TEXT, 0, Time[begin], High[begin] );
      ObjectSetText(" "+Time[begin]+" "+count, " "+Vjt, 20, "Times New Roman", numbers_color);
      
      //      ObjectCreate(" "+Time[begin]+" "+count+1, OBJ_TEXT, 0, Time[begin], Low[begin]-20*Point );
     // ObjectSetText(" "+Time[begin]+" "+count+1, " "+Vjt+" b", 20, "Times New Roman", Orange);
      }
      
            for( i=1;  i<=M; i++)
      {
         Buffer3[shift-i]=Vjt;// Buffer3[shift-i]=Vjt;this works!! for a buffer of the paterns numbers
         
       double  open0=iOpen(NULL,Min,iBarShift(NULL,Min,iTime(NULL,0,begin)));
       double close0=iClose(NULL,Min,iBarShift(NULL,Min,iTime(NULL,0,begin)));
       double high0=iHigh(NULL,Min,iBarShift(NULL,Min,iTime(NULL,0,begin)));
       double low0=iLow(NULL,Min,iBarShift(NULL,Min,iTime(NULL,0,begin)));
       
       int trend=0;
       double pipsh=0,pipsl=0,pipsc=0;
       
       if (close0>open0) {pipsc=close0-open0; if (close0-open0>25*Point*Digits){ trend=1;}}
       if (close0<open0) {pipsc=open0-close0; if (open0-close0>25*Point*Digits){trend=-1;}}
         
         Buffer4[shift-i]=trend;//iOpen(NULL,Min,iBarShift(NULL,Min,iTime(NULL,0,begin)));
         Buffer5[shift-i]=open0; 
         Buffer6[shift-i]=close0;
         Buffer7[shift-i]=high0-open0;
         Pips_low[shift-i]=open0-low0;
         Buffer1[shift-i]=pipsc;
      //   temp[begin-i]=in_neuro[i]; 
      }
      //Buffer3[begin]=Vjt;
      //---
      count++;
   }
   Print( "   ",TimeToStr(start_time,TIME_DATE|TIME_SECONDS) );
   Print( "   ",TimeToStr(some_time,TIME_DATE|TIME_SECONDS) ,"  = ",count );
   
   //---
}


//+------------------------------------------------------------------+
void err()
{
   int err=GetLastError();
   if(err!=0)
    {
     Print("error(",err,"): ",ErrorDescription(err));
    }
     return;
}
//---
//+------------------------------------------------------------------+ 
//|                                  | 
//| :                                                         | 
//|                                       | 
//| :                                                       | 
//|   source      -                                   | 
//|   dest        -                                    | 
//|   delimeter   -                                       | 
//+------------------------------------------------------------------+ 
int StrSplit(string source, string& dest[], string delimeter = ";") 
{ 
   int cnt = 0; 
   int last_pos = 0; 
   int pos = StringFind(source, delimeter, last_pos); 
    
   while (pos != -1) { 
      ArrayResize(dest, cnt + 1); 
      dest[cnt] = StringSubstr(source, last_pos, pos - last_pos); 
      cnt++; 
      last_pos = pos + 1; 
      pos = StringFind(source, delimeter, last_pos); 
   } 
   if (last_pos != 0 && last_pos < StringLen(source)){    
      ArrayResize(dest, cnt + 1); 
      dest[cnt] = StringSubstr(source, last_pos, StringLen(source) - last_pos); 
      cnt++; 
   } 
   return (cnt); 
}
//====================================================================+

